/* --------------------------------------------------
Author: Anastasios Pallas / tcpallas@gmail.com
Version 1.0
Last Update: 2018-12-20
-------------------------------------------------- */

// Initialize Canvas
var canvas = document.getElementById("canvas");
var context = canvas.getContext('2d');
var stage = new createjs.Stage("canvas");



/*
var demo_img = new Image();
demo_img.src = 'images/demo.png';

var demo = new createjs.Bitmap(demo_img);
demo.scaleX = pc2_on.scaleY = 1;
demo.x = config.center_x - 400;
demo.y = config.center_y - 300;

demo_img.onload = function () {
	stage.addChild(demo);
	stage.setChildIndex(demo, 1);
	stage.update();
}
*/



// PC #1 - Sender
var pc1_off_img = new Image();
pc1_off_img.src = 'images/pc1-off.png';

var pc1_off = new createjs.Bitmap(pc1_off_img);
pc1_off.scaleX = pc1_off.scaleY = 1;
pc1_off.x = config.center_x - 400;
pc1_off.y = config.center_y - 125;

pc1_off_img.onload = function () {
	stage.addChild(pc1_off);
	stage.setChildIndex(pc1_off, 1);
	stage.update();
}


var pc1_on_img = new Image();
pc1_on_img.src = 'images/pc1-on.png';

var pc1_on = new createjs.Bitmap(pc1_on_img);
pc1_on.scaleX = pc1_on.scaleY = 1;
pc1_on.x = config.center_x - 400;
pc1_on.y = config.center_y - 125;

pc1_on_img.onload = function () {
	stage.addChild(pc1_on);
	stage.setChildIndex(pc1_on, 2);
	stage.update();
}


// PC #2 - Receiver
var pc2_off_img = new Image();
pc2_off_img.src = 'images/pc2-off.png';

var pc2_off = new createjs.Bitmap(pc2_off_img);
pc2_off.scaleX = pc2_off.scaleY = 1;
pc2_off.x = config.center_x + 140;
pc2_off.y = config.center_y - 125;

pc2_off_img.onload = function () {
	stage.addChild(pc2_off);
	stage.setChildIndex(pc2_off, 3);
	stage.update();
}


var pc2_on_img = new Image();
pc2_on_img.src = 'images/pc2-on.png';

var pc2_on = new createjs.Bitmap(pc2_on_img);
pc2_on.scaleX = pc2_on.scaleY = 1;
pc2_on.x = config.center_x + 140;
pc2_on.y = config.center_y - 125;

pc2_on_img.onload = function () {
	stage.addChild(pc2_on);
	stage.setChildIndex(pc2_on, 4);
	stage.update();
}


// Sound Icon
var sound_icon_img = new Image();
sound_icon_img.src = 'images/sound-icon.png';

var sound_icon = new createjs.Bitmap(sound_icon_img);
sound_icon.scaleX = sound_icon.scaleY = 1;
sound_icon.x = config.center_x + 250;
sound_icon.y = config.center_y + 245;

sound_icon_img.onload = function () {
	stage.addChild(sound_icon);
	stage.setChildIndex(sound_icon, 5);
	stage.update();
}


// Status Box

var status_box = new createjs.Shape();
status_box.graphics.beginFill("#ffffff").beginStroke("#a1a1a1").setStrokeStyle(3).drawRoundRect(0, 0, 450, 60, 10);
status_box.x = config.center_x - 220;
status_box.y = config.center_y + 230;
stage.addChild(status_box);
stage.setChildIndex(status_box, 6);

// Status Text
var status_box_txt = new createjs.Text();
status_box_txt.text = config.status_off_text;
status_box_txt.font = "18px Arial";
status_box_txt.color = "#006699";
status_box_txt.textAlign = "center";
status_box_txt.x = config.center_x - 0;
status_box_txt.y = config.center_y + 250;
stage.addChild(status_box_txt);
stage.setChildIndex(status_box_txt, 7);
stage.update();




// PC #1 - Screen Display 
var pc1_screen_txt = new createjs.Text();
pc1_screen_txt.text = "00";
pc1_screen_txt.font = "32px Arial";
pc1_screen_txt.color = "#ffffff";
pc1_screen_txt.textAlign = "center";
pc1_screen_txt.x = config.center_x - 278;
pc1_screen_txt.y = config.center_y - 100;
stage.addChild(pc1_screen_txt);
stage.setChildIndex(pc1_screen_txt, 8);
stage.update();

// PC #2 - Screen Display 
var pc2_screen_txt = new createjs.Text();
pc2_screen_txt.text = "Ω";
pc2_screen_txt.font = "32px Arial";
pc2_screen_txt.color = "#ffffff";
pc2_screen_txt.textAlign = "center";
pc2_screen_txt.x = config.center_x + 278;
pc2_screen_txt.y = config.center_y - 100;
stage.addChild(pc2_screen_txt);
stage.setChildIndex(pc2_screen_txt, 9);
stage.update();




// Communication Analog Box
var analog_box_shadow = new createjs.Shape();
analog_box_shadow.graphics.beginFill("rgba(204, 204, 204, 0.5)").moveTo(0, 0).lineTo(300, 0).lineTo(10, 125).lineTo(0, 0);
analog_box_shadow.x = config.center_x - 145;
analog_box_shadow.y = config.center_y - 150;
stage.addChild(analog_box_shadow);
stage.setChildIndex(analog_box_shadow, 10);

var analog_box = new createjs.Shape();
analog_box.graphics.beginFill("#ffffff").beginStroke("#cccccc").setStrokeStyle(3).drawRoundRect(0, 0, 300, 140, 10);
analog_box.x = config.center_x - 150;
analog_box.y = config.center_y - 280;
stage.addChild(analog_box);
stage.setChildIndex(analog_box, 11);

var analog_box_txt = new createjs.Text();
analog_box_txt.text = config.analog_title;
analog_box_txt.font = "16px Arial";
analog_box_txt.color = "#283866";
analog_box_txt.textAlign = "center";
analog_box_txt.x = config.center_x - 0;
analog_box_txt.y = config.center_y - 300;
stage.addChild(analog_box_txt);
stage.setChildIndex(analog_box_txt, 12);

var analog_box_container = new createjs.Container();
analog_box_container.addChild(analog_box_shadow);
analog_box_container.addChild(analog_box);
analog_box_container.addChild(analog_box_txt);

stage.addChild(analog_box_container);
stage.update();


// PC #1 Communication Digital Box
// for characters
var pc1_digital_char_shadow = new createjs.Shape();
pc1_digital_char_shadow.graphics.beginFill("rgba(204, 204, 204, 0.5").moveTo(0, 0).lineTo(230, 0).lineTo(40, -70).lineTo(0, 0);
pc1_digital_char_shadow.x = config.center_x - 375;
pc1_digital_char_shadow.y = config.center_y + 85;
stage.addChild(pc1_digital_char_shadow);
stage.setChildIndex(pc1_digital_char_shadow, 13);

var pc1_digital_char = new createjs.Shape();
pc1_digital_char.graphics.beginFill("#ffffff").beginStroke("#cccccc").setStrokeStyle(3).drawRoundRect(0, 0, 230, 100, 10);
pc1_digital_char.x = config.center_x - 375;
pc1_digital_char.y = config.center_y + 80;
stage.addChild(pc1_digital_char);
stage.setChildIndex(pc1_digital_char, 14);

var pc1_digital_char_txt = new createjs.Text();
pc1_digital_char_txt.text = config.digital_title;
pc1_digital_char_txt.font = "16px Arial";
pc1_digital_char_txt.color = "#283866";
pc1_digital_char_txt.textAlign = "center";
pc1_digital_char_txt.x = config.center_x - 260;
pc1_digital_char_txt.y = config.center_y + 185;
stage.addChild(pc1_digital_char_txt);
stage.setChildIndex(pc1_digital_char_txt, 15);

var pc1_digital_char_container = new createjs.Container();
pc1_digital_char_container.addChild(pc1_digital_char_shadow);
pc1_digital_char_container.addChild(pc1_digital_char);
pc1_digital_char_container.addChild(pc1_digital_char_txt);

stage.addChild(pc1_digital_char_container);
stage.update();



// for digits
var pc1_digital_digits_shadow = new createjs.Shape();
pc1_digital_digits_shadow.graphics.beginFill("rgba(204, 204, 204, 0.5").moveTo(0, 0).lineTo(80, 0).lineTo(30, -70).lineTo(0, 0);
pc1_digital_digits_shadow.x = config.center_x - 320;
pc1_digital_digits_shadow.y = config.center_y + 85;
stage.addChild(pc1_digital_digits_shadow);
stage.setChildIndex(pc1_digital_digits_shadow, 16);

var pc1_digital_digits = new createjs.Shape();
pc1_digital_digits.graphics.beginFill("#ffffff").beginStroke("#cccccc").setStrokeStyle(3).drawCircle(0, 0, 50);
pc1_digital_digits.x = config.center_x - 280;
pc1_digital_digits.y = config.center_y + 120;
stage.addChild(pc1_digital_digits);
stage.setChildIndex(pc1_digital_digits, 17);

var pc1_digital_digits_txt = new createjs.Text();
pc1_digital_digits_txt.text = config.digital_title;
pc1_digital_digits_txt.font = "16px Arial";
pc1_digital_digits_txt.color = "#283866";
pc1_digital_digits_txt.textAlign = "center";
pc1_digital_digits_txt.x = config.center_x - 275;
pc1_digital_digits_txt.y = config.center_y + 180;
stage.addChild(pc1_digital_digits_txt);
stage.setChildIndex(pc1_digital_digits_txt, 18);

var pc1_digital_digits_container = new createjs.Container();
pc1_digital_digits_container.addChild(pc1_digital_digits_shadow);
pc1_digital_digits_container.addChild(pc1_digital_digits);
pc1_digital_digits_container.addChild(pc1_digital_digits_txt);

stage.addChild(pc1_digital_digits_container);
stage.update();




// PC #2 Communication Digital Box
// for characters
var pc2_digital_char_shadow = new createjs.Shape();
pc2_digital_char_shadow.graphics.beginFill("rgba(204, 204, 204, 0.5").moveTo(0, 0).lineTo(230, 0).lineTo(160, -70).lineTo(0, 0);
pc2_digital_char_shadow.x = config.center_x + 150;
pc2_digital_char_shadow.y = config.center_y + 85;
stage.addChild(pc2_digital_char_shadow);
stage.setChildIndex(pc2_digital_char_shadow, 19);

var pc2_digital_char = new createjs.Shape();
pc2_digital_char.graphics.beginFill("#ffffff").beginStroke("#cccccc").setStrokeStyle(3).drawRoundRect(0, 0, 230, 100, 10);
pc2_digital_char.x = config.center_x + 150;
pc2_digital_char.y = config.center_y + 80;
stage.addChild(pc2_digital_char);
stage.setChildIndex(pc2_digital_char, 20);

var pc2_digital_char_txt = new createjs.Text();
pc2_digital_char_txt.text = config.digital_title;
pc2_digital_char_txt.font = "16px Arial";
pc2_digital_char_txt.color = "#283866";
pc2_digital_char_txt.textAlign = "center";
pc2_digital_char_txt.x = config.center_x + 265;
pc2_digital_char_txt.y = config.center_y + 185;
stage.addChild(pc2_digital_char_txt);
stage.setChildIndex(pc2_digital_char_txt, 21);

var pc2_digital_char_container = new createjs.Container();
pc2_digital_char_container.addChild(pc2_digital_char_shadow);
pc2_digital_char_container.addChild(pc2_digital_char);
pc2_digital_char_container.addChild(pc2_digital_char_txt);

stage.addChild(pc2_digital_char_container);
stage.update();


// for digits
var pc2_digital_digits_shadow = new createjs.Shape();
pc2_digital_digits_shadow.graphics.beginFill("rgba(204, 204, 204, 0.5").moveTo(0, 0).lineTo(80, 0).lineTo(60, -70).lineTo(0, 0);
pc2_digital_digits_shadow.x = config.center_x + 240;
pc2_digital_digits_shadow.y = config.center_y + 85;
stage.addChild(pc2_digital_digits_shadow);
stage.setChildIndex(pc2_digital_digits_shadow, 22);

var pc2_digital_digits = new createjs.Shape();
pc2_digital_digits.graphics.beginFill("#ffffff").beginStroke("#cccccc").setStrokeStyle(3).drawCircle(0, 0, 50);
pc2_digital_digits.x = config.center_x + 280;
pc2_digital_digits.y = config.center_y + 120;
stage.addChild(pc2_digital_digits);
stage.setChildIndex(pc2_digital_digits, 23);

var pc2_digital_digits_txt = new createjs.Text();
pc2_digital_digits_txt.text = config.digital_title;
pc2_digital_digits_txt.font = "16px Arial";
pc2_digital_digits_txt.color = "#283866";
pc2_digital_digits_txt.textAlign = "center";
pc2_digital_digits_txt.x = config.center_x + 280;
pc2_digital_digits_txt.y = config.center_y + 180;
stage.addChild(pc2_digital_digits_txt);
stage.setChildIndex(pc2_digital_digits_txt, 24);

var pc2_digital_digits_container = new createjs.Container();
pc2_digital_digits_container.addChild(pc2_digital_digits_shadow);
pc2_digital_digits_container.addChild(pc2_digital_digits);
pc2_digital_digits_container.addChild(pc2_digital_digits_txt);

stage.addChild(pc2_digital_digits_container);
stage.update();


// Digital Sign Spot
var digital_spot = new createjs.Shape();
digital_spot.graphics.beginFill("#01c0f6").beginStroke("#ffffff").setStrokeStyle(3).drawCircle(0, 0, 10);
digital_spot.x = config.center_x - 375; // Animation nodes: PC#1(-375, -14; -375, +12; -235, +12) 
digital_spot.y = config.center_y - 14;	// Animation nodes: PC#2(+240, +12; +375, +12; +375, -14)
stage.addChild(digital_spot);
stage.setChildIndex(digital_spot, 25);
stage.update();


// Analog Connection Line
var analog_line = new createjs.Shape();
analog_line.graphics.beginStroke("#ee1c25").setStrokeStyle(3).moveTo(0, 0).lineTo(0, -32).lineTo(340 ,-32).lineTo(340, 0);
analog_line.x = config.center_x - 173;
analog_line.y = config.center_y + 7;
stage.addChild(analog_line);
stage.setChildIndex(analog_line, 26);
stage.update();


// Analog Sign Spot
var analog_spot = new createjs.Shape();
analog_spot.graphics.beginFill("#ffab18").beginStroke("#ffffff").setStrokeStyle(3).drawCircle(0, 0, 10);
analog_spot.x = config.center_x - 173; // Animation nodes: (-173, -5; -173, -25; +168, -25; +168, -5)
analog_spot.y = config.center_y - 5;
stage.addChild(analog_spot);
stage.setChildIndex(analog_spot, 27);
stage.update();

// Cloud
var cloud_img = new Image();
cloud_img.src = 'images/cloud.png';

var cloud = new createjs.Bitmap(cloud_img);
cloud.scaleX = cloud.scaleY = 1;
cloud.x = config.center_x - 100;
cloud.y = config.center_y - 105;

cloud_img.onload = function () {
	stage.addChild(cloud);
	stage.setChildIndex(cloud, 28);
	stage.update();
}



// Digital Grid
var digital_grid_digits = new createjs.Shape();
digital_grid_digits.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(0, -40).lineTo(0, 20);
digital_grid_digits.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(25, -40).lineTo(25, 20);
digital_grid_digits.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(50, -40).lineTo(50, 20);
digital_grid_digits.x = config.center_x - 305;
digital_grid_digits.y = config.center_y + 130;

var digital_grid_char = new createjs.Shape();
digital_grid_char.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(0, -40).lineTo(0, 20);
digital_grid_char.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(25, -40).lineTo(25, 20);
digital_grid_char.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(50, -40).lineTo(50, 20);
digital_grid_char.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(75, -40).lineTo(75, 20);
digital_grid_char.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(100, -40).lineTo(100, 20);
digital_grid_char.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(125, -40).lineTo(125, 20);
digital_grid_char.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(150, -40).lineTo(150, 20);
digital_grid_char.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(175, -40).lineTo(175, 20);
digital_grid_char.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(200, -40).lineTo(200, 20);
digital_grid_char.x = config.center_x - 305;
digital_grid_char.y = config.center_y + 130;

// Digital Signs
var digital_sign_00 = new createjs.Shape();
digital_sign_00.graphics.beginStroke("#01c0f6").setStrokeStyle(2).moveTo(0, 0).lineTo(25, 0).lineTo(50, 0);
digital_sign_00.x = config.center_x - 305;
digital_sign_00.y = config.center_y + 130;

var digital_sign_01 = new createjs.Shape();
digital_sign_01.graphics.beginStroke("#01c0f6").setStrokeStyle(2).moveTo(0, 0).lineTo(25, 0).lineTo(25, -25).lineTo(50, -25);
digital_sign_01.x = config.center_x - 305;
digital_sign_01.y = config.center_y + 130;

var digital_sign_10 = new createjs.Shape();
digital_sign_10.graphics.beginStroke("#01c0f6").setStrokeStyle(2).moveTo(0, -25).lineTo(25, -25).lineTo(25, 0).lineTo(50, 0);
digital_sign_10.x = config.center_x - 305;
digital_sign_10.y = config.center_y + 130;

var digital_sign_11 = new createjs.Shape();
digital_sign_11.graphics.beginStroke("#01c0f6").setStrokeStyle(2).moveTo(0, -25).lineTo(25, -25).lineTo(50, -25);
digital_sign_11.x = config.center_x - 305;
digital_sign_11.y = config.center_y + 130;

var digital_sign_8bits = new createjs.Shape();
digital_sign_8bits.graphics.beginStroke("#01c0f6").setStrokeStyle(2).moveTo(0, 0);
digital_sign_8bits.x = config.center_x - 305;
digital_sign_8bits.y = config.center_y + 130;

var digital_sign_txt = new createjs.Text();
digital_sign_txt.text = "1  0";
digital_sign_txt.font = "15px Courier";
digital_sign_txt.color = "#283866";
digital_sign_txt.textAlign = "left";
digital_sign_txt.x = config.center_x - 300;
digital_sign_txt.y = config.center_y + 145;

// create a container for digital sign
var digital_sign_container = new createjs.Container();
stage.addChild(digital_sign_container);
stage.setChildIndex(digital_sign_container, 29);
stage.update();





// Analog Grid
var analog_grid = new createjs.Shape();
analog_grid.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(-25, 0).lineTo(225, 0);	// horizontal
analog_grid.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(0, -40).lineTo(0, 40);
analog_grid.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(50, -40).lineTo(50, 40);
analog_grid.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(100, -40).lineTo(100, 40);
analog_grid.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(150, -40).lineTo(150, 40);
analog_grid.graphics.beginStroke("#cccccc").setStrokeDash([8, 4], 0).moveTo(200, -40).lineTo(200, 40);
analog_grid.x = config.center_x - 105;
analog_grid.y = config.center_y - 220;

// Analog Signs
var sinewave_00 = new createjs.Shape();
var x_old = 0;
var y_old = 0;
for (var x = 0.05; x <= 50; x += 0.05) {
	var y = -25 * Math.sin(x * 2 * Math.PI / 50); // height=25, length=50
	sinewave_00.graphics.setStrokeStyle(2).beginStroke("orange").moveTo(x_old, y_old).lineTo(x, y);
	x_old = x;
	y_old = y;
}
sinewave_00.x = config.center_x - 105;	// -105, -55, -5, +45
sinewave_00.y = config.center_y - 220;

var sinewave_01 = new createjs.Shape();
var x_old = 0;
var y_old = 0;
for (var x = 0.05; x <= 50; x += 0.05) {
	var y = -50 * Math.sin(x * 2 * Math.PI / 50); // height=50, length=50
	sinewave_01.graphics.setStrokeStyle(2).beginStroke("orange").moveTo(x_old, y_old).lineTo(x, y);
	x_old = x;
	y_old = y;
}
sinewave_01.x = config.center_x - 105;
sinewave_01.y = config.center_y - 220;

var sinewave_10 = new createjs.Shape();
var x_old = 0;
var y_old = 0;
for (var x = 0.05; x <= 50; x += 0.05) {
	var y = 25 * Math.sin(x * 2 * Math.PI / 50); // height=25, length=50
	sinewave_10.graphics.setStrokeStyle(2).beginStroke("orange").moveTo(x_old, y_old).lineTo(x, y);
	x_old = x;
	y_old = y;
}
sinewave_10.x = config.center_x - 105;
sinewave_10.y = config.center_y - 220;

var sinewave_11 = new createjs.Shape();
var x_old = 0;
var y_old = 0;
for (var x = 0.05; x <= 50; x += 0.05) {
	var y = 50 * Math.sin(x * 2 * Math.PI / 50); // height=50, length=50
	sinewave_11.graphics.setStrokeStyle(2).beginStroke("orange").moveTo(x_old, y_old).lineTo(x, y);
	x_old = x;
	y_old = y;
}
sinewave_11.x = config.center_x - 105;
sinewave_11.y = config.center_y - 220;

var analog_sign_txt = new createjs.Text();
analog_sign_txt.text = "00    00   00    00";
analog_sign_txt.font = "15px Courier";
analog_sign_txt.color = "#283866";
analog_sign_txt.textAlign = "left";
analog_sign_txt.x = config.center_x - 90;
analog_sign_txt.y = config.center_y - 165;

// create a container for analog sign
var analog_sign_container = new createjs.Container();
stage.addChild(analog_sign_container);
stage.setChildIndex(analog_sign_container, 30);
stage.update();



// Dial-up Sound
if (!createjs.Sound.initializeDefaultPlugins()) {
	console.log("ERROR: Sound of Dialup cannot play in this browser!");
}

var audioPath = "audio/";
var sounds = [
        {id:"dialup", src:"modem-dialup.mp3"}
];

// createjs.Sound.alternateExtensions = ["mp3"];




stage.update();